<template>

  <div style="display: flex; justify-content: space-between;">
    <div>
      <select v-model="logLevel" @click="updateLog()">
          <option></option>
          <option>ERROR</option>
          <option>WARN</option>
      </select>
    </div>
    <div>
        <a href="#" @click.prevent="goToSubtask()">Подзадание</a>
    </div>
  </div>

  <loader :active="loaderActive" message="Загрузка данных" />  
  <pre style="word-wrap: break-word; white-space: pre-wrap;">
{{log}}
  </pre>
</template>


<script>
import { defineComponent, ref, } from "vue";
import {redouteProvider} from  "../config/provider.js"
import Loader from '../components/Loader.vue'
import router from "../router/index"
import axios from "axios"

export default defineComponent ({
  name: 'App',
  components: {
    Loader
  },
  setup() {
    let config = {}
    const log = ref("")
    const logLevel = ref("")
    const loaderActive = ref(true)

    updateLog()

    function updateLog() {
      const url = new URL(window.location.href)
      const task_id = url.searchParams.get("task_id")
      const job_id = url.searchParams.get("job_id")
      let job = '&job_id=' + job_id
      if (!job_id) job = ''
      let name = ''
      if (logLevel.value) name = '&name=' + logLevel.value
      let request = redouteProvider + '/log?task_id=' + task_id + job + name
      axios.get(request, config)
        .then(response => { 
          log.value = response.data
          loaderActive.value = false
        })    
        .catch(error => { 
          log.value = error.message
          loaderActive.value = false
        })    
    }
    
    function goToSubtask() {
      const url = new URL(window.location.href)
      const task_id = url.searchParams.get("task_id")

      router.push({ path: '/job', query: { task_id: task_id } }) 
    }


    return {
      log,
      loaderActive,
      logLevel,
      updateLog,
      goToSubtask,
    }
  }
}
)
</script>